using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.ObjectBuilder;
using Microsoft.Practices.CompositeWeb;

namespace Locator.Admin.Views
{
    public class DefaultViewPresenter : Presenter<IDefaultView>, IDisposable
    {
        private readonly IAdminController controller;

        public DefaultViewPresenter([CreateNew] IAdminController controller)
        {
            this.controller = controller;
        }

        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }

        protected virtual void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (controller != null)
                {
                    controller.Dispose();
                }
            }
        }

        ~DefaultViewPresenter()
        {
            Dispose(false);
        }
    }
}
