﻿using System;
using System.Collections.Generic;
using System.Linq;
using DataAccess.BusinessEntities;

namespace DataAccess
{
    public interface IUnitOfWork : IDisposable
    {
        IRepository<PersonalLocation> PersonalLocations { get; }
        IRepository<Store> Stores { get; }
        IRepository<User> Users { get; }
        IRepository<Product> Products { get; }
        IRepository<Substance> Substances { get; }
        IRepository<Container> Containers { get; }
        void Commit();
    }
}