using System;

namespace Locator.GeoLocation.BusinessEntities
{
    [Serializable]
    public class Address
    {
        /// <summary>
        /// Gets or sets the street address.
        /// </summary>
        /// <value>
        /// The street address.
        /// </value>
        public string AddressLine { get; set; }

        /// <summary>
        /// Gets or sets the province/state/prefecture/county/regional municipality.
        /// </summary>
        /// <value>
        /// The the province/state/prefecture/county/regional municipality.
        /// </value>
        public string AdminDistrict { get; set; }

        /// <summary>
        /// Gets or sets the country.
        /// </summary>
        /// <value>
        /// The country.
        /// </value>
        public string CountryRegion { get; set; }

        public string District { get; set; }

        public string FormattedAddress { get; set; }

        /// <summary>
        /// Gets or sets the hamlet/village/town/city.
        /// </summary>
        /// <value>
        /// The hamlet/village/town/city..
        /// </value>
        public string Locality { get; set; }

        public string PostalCode { get; set; }

        public string PostalTown { get; set; }
    }
}
