﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Locator.LcboServices.BusinessEntities;

namespace Locator.LcboServices.LcboProductsService.Services
{
    public interface ILcboProductsService : IDisposable
    {
        /// <summary>
        /// Gets all alcoholic products from the LCBO website.
        /// </summary>
        /// <returns></returns>
        List<LcboProduct> GetAllProducts();

        /// <summary>
        /// Gets the product description.
        /// </summary>
        /// <param name="lcboProductId">The lcbo product id.</param>
        /// <returns></returns>
        string GetProductDescription(string lcboProductId);
    }
}
