﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Locator.LcboServices.BusinessEntities;

namespace Locator.LcboService.Interface.Services
{
    public interface ILcboInventoryService
    {
        /// <summary>
        /// Retrieves the inventory items for the given product IDs.
        /// </summary>
        /// <remarks>
        /// LCBO pages are parsed as HtmlAgilityPack HtmlDocuments
        /// </remarks>
        /// <param name="productIds">The product ids.</param>
        /// <returns>List of inventory info items,</returns>
        List<LcboInventoryData2> RetrieveMatches(IEnumerable<int> productIds);
    }
}
