using System;
using System.Globalization;

namespace LcboServices.BusinessEntities
{
    public class LcboInventoryData
    {
        /// <summary>
        /// Gets or sets the address line.
        /// </summary>
        /// <value>The address line.</value>
        public string AddressLine { get; set; }

        /// <summary>
        /// Gets or sets the city.
        /// </summary>
        /// <value>The city.</value>
        public string City { get; set; }

        /// <summary>
        /// Gets or sets the number in stock.
        /// </summary>
        /// <value>The number in stock.</value>
        public int NumberInStock { get; set; }

        /// <summary>
        /// Gets the civic address.
        /// </summary>
        /// <value>The civic address.</value>
        public string CivicAddress
        {
            get { return String.Format(CultureInfo.CurrentCulture, "{0} {1} ON", this.AddressLine, this.City); }
        }

        /// <summary>
        /// Gets or sets the store number.
        /// </summary>
        /// <value>The store number.</value>
        public int StoreNumber { get; set; }
    }
}
