using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using Locator.Common.Model;
using System.Data.Objects;

namespace Locator.Common.DataAccess
{
    public interface IRepository<T> where T : class, IEntity
    {
        IQueryable<T> FindAll();
        IQueryable<T> FindWhere(Expression<Func<T, bool>> predicate);
        T FindById(int id);
        void Add(T entity);
        void Remove(T entity);
    }
}
