﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Locator.Common.DataAccess.Interface;
using Locator.Common.Model;

namespace Locator.Common.UnitTests
{
    public class InMemoryUnitOfWork : IUnitOfWork
    {
        /// <summary>
        /// Initializes a new instance of the InMemoryUnitOfWork class.
        /// </summary>
        public InMemoryUnitOfWork()
        {
            this.Committed = false;
            this.Disposed = false;
        }

        public IRepository<Store> Stores { get; set; }

        public IRepository<User> Users { get; set; }

        public void Commit()
        {
            this.Committed = true;
        }

        public bool Committed { get; set; }

        public bool Disposed { get; set; }

        public void Dispose()
        {
            this.Disposed = true;
        }
    }
}