using System;
using System.Collections.Generic;
using System.Linq;
using Locator.Common.Model;

namespace Locator.Common.UnitTests
{
    public class TestPocBase
    {
        public TestPocBase()
        {
            this.StoreData = StoreObjectMother.CreateStores().ToList();
            this.StoreRepository = new InMemoryRepository<Store>(this.StoreData);
            this.UserData = UserObjectMother.CreateUsers().ToList();
            this.UserRepository = new InMemoryRepository<User>(this.UserData);
            this.UnitOfWork = new InMemoryUnitOfWork();
            this.UnitOfWork.Stores = this.StoreRepository;
            this.UnitOfWork.Users = this.UserRepository;
        }

        protected IList<Store> StoreData { get; set; }
        protected IList<User> UserData { get; set; }
        protected InMemoryRepository<Store> StoreRepository { get; set; }
        protected InMemoryRepository<User> UserRepository { get; set; }
        protected InMemoryUnitOfWork UnitOfWork { get; set; }
    }
}
