using System;
using System.Collections.Generic;
using DataAccess.BusinessEntities;

namespace Locator.Products
{
    public interface IProductsController : IDisposable
    {
        List<Product> GetAllProducts();
        void DeleteProductForCurrentUser(int ID);
        void AddProductForCurrentUser(int productId);
        List<Product> FindProductsContainingSubstanceName(string substanceName);
        List<Product> FindProductsContainingSubstance(int substanceId);
        List<Substance> GetAllSubstances();
        List<UserProduct> FindProductsContainingName(string name);
        List<UserProduct> GetProductsForCurrentUser();

        void ProductSearch();
    }
}
