using System;
using System.Collections.Generic;
using DataAccess;
using DataAccess.BusinessEntities;

namespace Locator.Stores
{
    public interface IStoresController : IDisposable
    {
        List<PersonalLocation> GetPersonalLocationsForCurrentUser();
        List<Store> FindStoresByPostalCode(string postalCode, int radiusInKm);
        List<Store> FindStoresByLatitudeAndLongitude(decimal latitude, decimal longitude, int radiusInKm);
        List<Store> FindStoresByPersonalLocation(int personalLocationId, int radiusInKm);
        List<Store> GetStoresForCurrentUser();
        List<Store> FindStoresNotUsedByCurrentUser();
        List<string> AllCities();
        List<Store> FindStoresInCity(string cityName);
        void AddStoreForCurrentUser(int storeNumber);
        void DeleteStoreForCurrentUser(int storeNumber);

        void Search();
    }
}
