﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Locator.LcboServices.PageLoaders.Services;
using System.Threading.Tasks;
using HtmlAgilityPack;
using System.Globalization;
using System.IO;
using System.Reflection;

namespace LcboServices.Common.Tests
{
    public abstract class LocalFilePageRetriever : IPageRetriever
    {
        protected abstract string BuildFileNameWithoutPath(string parameter);

        protected abstract string GetHtmlString(string parameter);

        public Task<HtmlDocument> RetrievePageHtmlAsyncWithPost(string parameter)
        {
            throw new NotImplementedException();
        }

        public void RetrievePageHtmlsAsync(int[] parameters, Action<Task<HtmlDocument>[]> callback)
        {
            Task<HtmlDocument>[] myTasks = new Task<HtmlDocument>[parameters.Count()];
            int taskIndex = 0;
            foreach (int parameter in parameters)
            {
                myTasks[taskIndex] = this.GetPageTask(parameter);
                taskIndex++;
            }

            Action<Task<HtmlDocument>[]> completedAction = (completedTasks) => { callback(completedTasks); };

            Task.Factory.ContinueWhenAll<HtmlDocument>(myTasks, completedAction);
        }

        private Task<HtmlDocument> GetPageTask(int parameter)
        {
            TaskCompletionSource<HtmlDocument> pageRetrievalTaskCompletionSource = new TaskCompletionSource<HtmlDocument>();
            pageRetrievalTaskCompletionSource.SetResult(this.RetrievePageHtml(parameter.ToString(CultureInfo.InvariantCulture)));
            return pageRetrievalTaskCompletionSource.Task;
        }



        public HtmlDocument RetrievePageHtml(string parameter)
        {
            HtmlDocument doc = new HtmlDocument();
            doc.LoadHtml(this.GetHtmlString(parameter));
            //string file = this.BuildFileNameWithoutPath(parameter);
            //LcboServices.Common.Tests.Properties.Resources
            //Assembly assemblyGetExecutingAssembly = Assembly.GetExecutingAssembly();
            //string[] all = assemblyGetExecutingAssembly.GetManifestResourceNames();
            //using (Stream stream = assemblyGetExecutingAssembly.GetManifestResourceStream(file))
            //{
            //    using (TextReader reader = new StreamReader(stream))
            //    {
            //        doc.Load(reader);
            //    }
            //}

            //doc.Load(String.Format(@"..\..\..\TestLcbo\{0}", this.BuildFileNameWithoutPath(parameter)));
            return doc;
        }
    }
}