﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="Inventory.ascx.cs" Inherits="Locator.Inventory.Views.Inventory" %>
<%@ Register Assembly="Microsoft.Practices.Web.UI.WebControls" Namespace="Microsoft.Practices.Web.UI.WebControls"
    TagPrefix="pp" %>
<script>
    $(function () {
        DRINKLOCATOR.inventorySetup();
    });
</script>
<h1>
    Inventory</h1>
<div class="row">
    <div class="column grid_5">
        <asp:DropDownList runat="server" ID="StoreDropDownList" DataSourceID="StoresDataSource"
            DataTextField="Address" DataValueField="Id" Width="100%" />
    </div>
    <div class="column grid_7">
    </div>
</div>
<div class="row">
    <div class="column grid_5">
        <asp:DropDownList runat="server" ID="ProductDropDownList" DataSourceID="ProductsDataSource"
            DataTextField="Name" DataValueField="Id" Width="100%" />
    </div>
    <div class="column grid_7">
    </div>
</div>
<div class="row">
    <div class="column grid_12">
        <asp:Button runat="server" ID="SearchButton" Text="Search" OnClick="SearchButton_Click" />
    </div>
</div>
<asp:ListView runat="server" ID="ListViewProducts" DataSourceID="InventoryDataSource">
    <LayoutTemplate>
        <div class="row">
            <div class="column grid_6">
                <div id="itemPlaceHolder" runat="server" />
            </div>
            <div class="column  grid_6" id="storesMap">
                <span id="spanNoMap" style="display: none">Map not available</span><br />
            </div>
        </div>
    </LayoutTemplate>
    <ItemTemplate>
        <div class="row">
            <div class="column grid_6 storeAddress" data-latitude='<%# Eval("Store.Latitude") %>'
                data-longitude='<%# Eval("Store.Longitude") %>'>
                <b>
                    <asp:Literal runat="server" ID="LiteralAddress" Text='<%# (string)Eval("Store.Address") + " " + (string)Eval("Store.City") %>' />
                </b>
            </div>
        </div>
        <div class="row">
            <div class="column grid_3">
                <b>Product </b>
            </div>
            <div class="column grid_3">
                <b>Amount </b>
            </div>
        </div>
        <asp:ListView runat="server" ID="ListViewProductDetails" DataSource='<%# Eval("Inventory") %>'>
            <LayoutTemplate>
                <div id="itemPlaceHolder" runat="server" />
            </LayoutTemplate>
            <ItemTemplate>
                <div class="row">
                    <div class="column grid_3">
                        <asp:Literal runat="server" ID="LiteralName" Text='<%# Eval("Product.Name") %>' />
                    </div>
                    <div class="column grid_3">
                        <asp:Literal runat="server" ID="LiteralNumberInStock" Text='<%# Eval("NumberInStock") %>' />
                    </div>
                </div>
            </ItemTemplate>
        </asp:ListView>
    </ItemTemplate>
</asp:ListView>
<pp:ObjectContainerDataSource ID="InventoryDataSource" runat="server" DataObjectTypeName="Inventory.BusinessEntities.StoreWithInventory" />
<pp:ObjectContainerDataSource ID="StoresDataSource" runat="server" DataObjectTypeName="DataAccess.BusinessEntities.Store" />
<pp:ObjectContainerDataSource ID="ProductsDataSource" runat="server" DataObjectTypeName="Inventory.BusinessEntities.ProductListItem" />
<div class="row">
    <div class="column grid_12">
        &nbsp;
    </div>
</div>
<input type="hidden" id="MapKeyHiddenField" value="<%=MapKey %>" />
<input type="hidden" id="ResultsHiddenField" value='<%=ResultsAsJson %>' />
<script charset="UTF-8" type="text/javascript" src="http://ecn.dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=7.0&mkt=en-CA"></script>
<script type="text/javascript">
    try {
        //alert("before map");
        DRINKLOCATOR.getMap($("#MapKeyHiddenField").val(), $.parseJSON($("#ResultsHiddenField").val()), "storesMap");
    }
    catch (error) {
        //alert(error);

        $("#spanNoMap").removeAttr("style");
        $("#storesMap").width("auto").height("auto"); //.attr("style", "width:auto").attr("style", "height:auto");
    }
</script>
