﻿using System;
using Microsoft.Practices.ObjectBuilder;
using Microsoft.Practices.CompositeWeb.Web.UI;
using System.Collections.Generic;
using Microsoft.Practices.Web.UI.WebControls;
using DataAccess.BusinessEntities;

namespace Locator.PersonalLocations.Views
{
    public partial class UsersPersonalLocations : UserControl, IUsersPersonalLocationsView
    {
        private UsersPersonalLocationsPresenter presenter;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!this.IsPostBack)
            {
                this.presenter.OnViewInitialized();
            }

            this.presenter.OnViewLoaded();
        }

        [CreateNew]
        public UsersPersonalLocationsPresenter Presenter
        {
            get { return this.presenter; }
            set
            {
                if (value == null)
                    throw new ArgumentNullException("value");

                this.presenter = value;
                this.presenter.View = this;
            }
        }

        public void SetPersonalLocations(List<PersonalLocation> locations)
        {
            this.PersonalLocationsDataSource.DataSource = locations;
        }

        protected void PersonalLocationsDataSource_Deleted(object sender, ObjectContainerDataSourceStatusEventArgs e)
        {
            this.presenter.OnPersonalLocationDeleted(e.Instance as PersonalLocation);
        }

        protected void AddPersonalLocationsLinkButton_Click(object sender, EventArgs e)
        {
            this.presenter.OnAddPersonalLocationsClicked();
        }

        public override void Dispose()
        {
            if (this.presenter != null)
            {
                this.presenter.Dispose();
            }

            base.Dispose();
        }
    }
}

