﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using DataAccess.BusinessEntities;
using Locator.Products;

namespace Locator.Services
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the interface name "IProductsService" in both code and config file together.
    [ServiceContract]
    public interface IProductsService
    {
        [OperationContract]
        [ApplyDataContractResolver]
        List<Product> GetAllProducts();

        [OperationContract]
        [ApplyDataContractResolver]
        void DeleteProductForCurrentUser(int ID);

        [OperationContract]
        [ApplyDataContractResolver]
        void AddProductForCurrentUser(int productId);

        [OperationContract]
        [ApplyDataContractResolver]
        List<Substance> GetAllSubstances();
        
        [OperationContract]
        [ApplyDataContractResolver]
        List<UserProduct> FindProductsContainingName(string name);
        
        [OperationContract]
        [ApplyDataContractResolver]
        List<UserProduct> GetProductsForCurrentUser();
    }
}
